# running

To interact with items (documents) in the 
database (collection), MongoDB uses a CRUD model
(Create Read Update Delete).

[CRUD operations](https://docs.mongodb.com/manual/crud/)

## start service

mongodb should be available as a system service:

```
sudo service mongod start
```

## interface

The first thing you have to decide before interacting
with the database is how you want to interact.

the mongodb shell is a javascript shell that can
be used from a command line on the mongodb server.

mongodb also has python language bindings.
there are multiple non-mongo-provided 
third party APIs and libraries too, so there
are multiple options.

## create (insert)

To insert documents into a collection:
* `db.collection.insertOne()`
* `db.collection.insertMany()`

Example: `db.users.insertOne({name:"Sue", age:26})`

## read (query)

To read documents from a collection,
use the find function:
* `db.collection.find()`

Example: `db.users.find({age:{$gt:18}})`

## update

To update documents in a collection:
* `db.collection.updateOne()`
* `db.collection.updateMany()`
* `db.collection.replaceOne()`

Example: `db.users.updateMany( {age:{$lt:18}, $set: {status: "reject"}} )`

## delete

Delete documents one at a time or en masse:
* `db.collection.deleteOne()`
* `db.collection.deleteMany()`

